--- linux-2.6.27.6/drivers/serial/8250.c	2008-11-14 01:56:21.000000000 +0800
+++ linux-2.6.27.6.yaffs/drivers/serial/8250.c	2011-05-08 18:00:02.000000000 +0800
@@ -96,10 +96,15 @@
  * standard enumeration mechanism.   Platforms that can find all
  * serial ports via mechanisms like ACPI or PCI need not supply it.
  */
+/*
 #ifndef SERIAL_PORT_DFNS
 #define SERIAL_PORT_DFNS
 #endif
-
+*/
+#ifdef SERIAL_PORT_DFNS
+#undef SERIAL_PORT_DFNS
+#define SERIAL_PORT_DFNS
+#endif
 static const struct old_serial_port old_serial_port[] = {
 	SERIAL_PORT_DFNS /* defined in asm/serial.h */
 };
@@ -1477,6 +1482,7 @@
 		up = list_entry(l, struct uart_8250_port, list);
 
 		iir = serial_in(up, UART_IIR);
+		//printk("-----iir %x---------\n",iir);
 		if (!(iir & UART_IIR_NO_INT)) {
 			serial8250_handle_port(up);
 
@@ -2760,6 +2766,11 @@
 		port.hub6		= p->hub6;
 		port.private_data	= p->private_data;
 		port.dev		= &dev->dev;
+	printk("register port at index %d "
+				"(IO%lx MEM%llx IRQ%d): %d\n", i,
+				p->iobase, (unsigned long long)p->mapbase,
+				p->irq, ret);  //mj
+
 		if (share_irqs)
 			port.flags |= UPF_SHARE_IRQ;
 		ret = serial8250_register_port(&port);
@@ -2896,10 +2907,13 @@
 
 	mutex_lock(&serial_mutex);
 
+	printk("-%s--1--\n",__func__);
 	uart = serial8250_find_match_or_unused(port);
+	printk("-%s--2--\n",__func__);
 	if (uart) {
 		uart_remove_one_port(&serial8250_reg, &uart->port);
 
+	printk("-%s--3--\n",__func__);
 		uart->port.iobase       = port->iobase;
 		uart->port.membase      = port->membase;
 		uart->port.irq          = port->irq;
@@ -2962,33 +2976,45 @@
 	for (i = 0; i < NR_IRQS; i++)
 		spin_lock_init(&irq_lists[i].lock);
 
+//	printk("--%s------------1-------\n",__func__);
 	ret = uart_register_driver(&serial8250_reg);
+//	printk("--%s------------2-------\n",__func__);
 	if (ret)
 		goto out;
 
+//	printk("--%s------------3-------\n",__func__);
 	serial8250_isa_devs = platform_device_alloc("serial8250",
 						    PLAT8250_DEV_LEGACY);
+//	printk("--%s------------4-------\n",__func__);
+//	serial8250_isa_devs = platform_device_alloc("serial8250",PLAT8250_DEV_EXAR_ST16C554);
 	if (!serial8250_isa_devs) {
 		ret = -ENOMEM;
 		goto unreg_uart_drv;
 	}
 
 	ret = platform_device_add(serial8250_isa_devs);
+	printk("--%s------------5-------\n",__func__);
 	if (ret)
 		goto put_dev;
 
 	serial8250_register_ports(&serial8250_reg, &serial8250_isa_devs->dev);
 
+	printk("--%s------------6-------\n",__func__);
 	ret = platform_driver_register(&serial8250_isa_driver);
+//	printk("--%s------------7-------\n",__func__);
 	if (ret == 0)
 		goto out;
 
 	platform_device_del(serial8250_isa_devs);
+//	printk("--%s------------8-------\n",__func__);
  put_dev:
+//	printk("--%s------------9-------\n",__func__);
 	platform_device_put(serial8250_isa_devs);
  unreg_uart_drv:
+//	printk("--%s------------10-------\n",__func__);
 	uart_unregister_driver(&serial8250_reg);
  out:
+//	printk("--%s-------------11------\n",__func__);
 	return ret;
 }
 
